//*****************************************************************************
//*****************************************************************************
//  FILENAME: TimerRTC.h
//   Version: 2.5, Updated on 2006/06/19 at 11:15:48
//  Generated by PSoC Designer ver 4.4  b1884 : 14 Jan, 2007
//
//  DESCRIPTION: Timer8 User Module C Language interface file
//               for the 22/24/27/29xxx PSoC family of devices
//-----------------------------------------------------------------------------
//  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************

#include <m8c.h>

#pragma fastcall16 TimerRTC_EnableInt                 //                 Proxy 1
#pragma fastcall16 TimerRTC_DisableInt                //                 Proxy 1
#pragma fastcall16 TimerRTC_Start                     //                 Proxy 1
#pragma fastcall16 TimerRTC_Stop                      //                 Proxy 1
#pragma fastcall16 TimerRTC_bReadTimer                // Read  DR0       Proxy 1
#pragma fastcall16 TimerRTC_bReadTimerSaveCV          // Read  DR0       Proxy 2
#pragma fastcall16 TimerRTC_WritePeriod               // Write DR1       Proxy 1
#pragma fastcall16 TimerRTC_bReadCompareValue         // Read  DR2       Proxy 1
#pragma fastcall16 TimerRTC_WriteCompareValue         // Write DR2       Proxy 1

// The following symbols are deprecated.
// They may be omitted in future releases
//
#pragma fastcall16 bTimerRTC_ReadCounter              // Read  DR0 "Obsolete"
#pragma fastcall16 bTimerRTC_CaptureCounter           // Read  DR0 "Obsolete"
#pragma fastcall16 bTimerRTC_ReadTimer                // Read  DR0 (Deprecated)
#pragma fastcall16 bTimerRTC_ReadTimerSaveCV          // Read  DR0 (Deprecated)
#pragma fastcall16 bTimerRTC_ReadCompareValue         // Read  DR2 (Deprecated)


//-------------------------------------------------
// Prototypes of the TimerRTC API.
//-------------------------------------------------

extern void TimerRTC_EnableInt(void);
extern void TimerRTC_DisableInt(void);
extern void TimerRTC_Start(void);
extern void TimerRTC_Stop(void);
extern BYTE TimerRTC_bReadTimer(void);
extern BYTE TimerRTC_bReadTimerSaveCV(void);
extern void TimerRTC_WritePeriod(BYTE bPeriod);
extern BYTE TimerRTC_bReadCompareValue(void);
extern void TimerRTC_WriteCompareValue(BYTE bCompareValue);

// The following functions are deprecated.
// They may be omitted in future releases
//
extern BYTE bTimerRTC_ReadCompareValue(void);       // Deprecated
extern BYTE bTimerRTC_ReadTimerSaveCV(void);        // Deprecated
extern BYTE bTimerRTC_ReadCounter(void);            // Obsolete
extern BYTE bTimerRTC_ReadTimer(void);              // Deprecated
extern BYTE bTimerRTC_CaptureCounter(void);         // Obsolete


//--------------------------------------------------
// Constants for TimerRTC API's.
//--------------------------------------------------

#define TimerRTC_CONTROL_REG_START_BIT         ( 0x01 )
#define TimerRTC_INT_REG_ADDR                  ( 0x0e1 )
#define TimerRTC_INT_MASK                      ( 0x10 )


//--------------------------------------------------
// Constants for TimerRTC user defined values
//--------------------------------------------------

#define TimerRTC_PERIOD                        ( 0x08 )
#define TimerRTC_COMPARE_VALUE                 ( 0x00 )


//-------------------------------------------------
// Register Addresses for TimerRTC
//-------------------------------------------------

#pragma ioport  TimerRTC_COUNTER_REG:   0x030              //DR0 Count register
BYTE            TimerRTC_COUNTER_REG;
#pragma ioport  TimerRTC_PERIOD_REG:    0x031              //DR1 Period register
BYTE            TimerRTC_PERIOD_REG;
#pragma ioport  TimerRTC_COMPARE_REG:   0x032              //DR2 Compare register
BYTE            TimerRTC_COMPARE_REG;
#pragma ioport  TimerRTC_CONTROL_REG:   0x033              //Control register
BYTE            TimerRTC_CONTROL_REG;
#pragma ioport  TimerRTC_FUNC_REG:  0x130                  //Function register
BYTE            TimerRTC_FUNC_REG;
#pragma ioport  TimerRTC_INPUT_REG: 0x131                  //Input register
BYTE            TimerRTC_INPUT_REG;
#pragma ioport  TimerRTC_OUTPUT_REG:    0x132              //Output register
BYTE            TimerRTC_OUTPUT_REG;
#pragma ioport  TimerRTC_INT_REG:       0x0e1              //Interrupt Mask Register
BYTE            TimerRTC_INT_REG;


//-------------------------------------------------
// TimerRTC Macro 'Functions'
//-------------------------------------------------

#define TimerRTC_Start_M \
   ( TimerRTC_CONTROL_REG |=  TimerRTC_CONTROL_REG_START_BIT )

#define TimerRTC_Stop_M  \
   ( TimerRTC_CONTROL_REG &= ~TimerRTC_CONTROL_REG_START_BIT )

#define TimerRTC_EnableInt_M   \
   M8C_EnableIntMask(  TimerRTC_INT_REG, TimerRTC_INT_MASK )

#define TimerRTC_DisableInt_M  \
   M8C_DisableIntMask( TimerRTC_INT_REG, TimerRTC_INT_MASK )


// end of file TimerRTC.h
