;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: TimerRTC.inc
;;   Version: 2.5, Updated on 2006/06/19 at 11:15:48
;;  Generated by PSoC Designer ver 4.4  b1884 : 14 Jan, 2007
;;
;;  DESCRIPTION: Assembler declarations for the Timer8 user module interface
;;               for the 22/24/27/29xxx PSoC family of devices
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"


;--------------------------------------------------
; Constants for TimerRTC API's.
;--------------------------------------------------

TimerRTC_CONTROL_REG_START_BIT:            equ 0x01    ; Control register start bit
TimerRTC_INT_REG:                          equ 0x0e1
TimerRTC_INT_MASK:                         equ 0x10


;--------------------------------------------------
; Constants for TimerRTC user defined values
;--------------------------------------------------

TimerRTC_PERIOD:                           equ 0x08
TimerRTC_COMPARE_VALUE:                    equ 0x00


;--------------------------------------------------
; Register Address Constants for TimerRTC
;--------------------------------------------------

TimerRTC_COUNTER_REG:                  equ 0x30   ; DR0 Counter register
TimerRTC_PERIOD_REG:                   equ 0x31   ; DR1 Period register
TimerRTC_COMPARE_REG:                  equ 0x32   ; DR2 CompareValue register
TimerRTC_CONTROL_REG:                  equ 0x33   ; Control register
TimerRTC_FUNC_REG:                     equ 0x30   ; Function register
TimerRTC_INPUT_REG:                    equ 0x31   ; Input register
TimerRTC_OUTPUT_REG:                   equ 0x32   ; Output register


;--------------------------------------------------
; TimerRTC Macro 'Functions'
;--------------------------------------------------

   macro TimerRTC_Start_M
   or    reg[TimerRTC_CONTROL_REG],  TimerRTC_CONTROL_REG_START_BIT
   endm

   macro TimerRTC_Stop_M
   and   reg[TimerRTC_CONTROL_REG], ~TimerRTC_CONTROL_REG_START_BIT
   endm

   macro TimerRTC_EnableInt_M
   M8C_EnableIntMask TimerRTC_INT_REG, TimerRTC_INT_MASK
   endm

   macro TimerRTC_DisableInt_M
   M8C_DisableIntMask TimerRTC_INT_REG, TimerRTC_INT_MASK
   endm


; end of file TimerRTC.inc
