;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: TimerRTCINT.asm
;;   Version: 2.5, Updated on 2006/06/19 at 11:15:48
;;  Generated by PSoC Designer ver 4.4  b1884 : 14 Jan, 2007
;;
;;  DESCRIPTION: Timer8 Interrupt Service Routine
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2004. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"
include "memory.inc"
include "TimerRTC.inc"


;-----------------------------------------------
;  Global Symbols
;-----------------------------------------------
export  _TimerRTC_ISR


AREA InterruptRAM (RAM,REL,CON)

;@PSoC_UserCode_INIT@ (Do not change this line.)
;---------------------------------------------------
; Insert your custom declarations below this banner
;---------------------------------------------------

; Variaveis para ambos assembler e C compiler (Simbolos globais)
export	_slice_counter
export	slice_counter
export	_time_slot_counter
export	time_slot_counter

; Declara variavel local 16-bit
_slice_counter:     
 slice_counter:			blkw 1	; Contador tempo
_time_slot_counter:     
 time_slot_counter:		blkw 1	; Indica quem interrompeu

;---------------------------------------------------
; Insert your custom declarations above this banner
;---------------------------------------------------
;@PSoC_UserCode_END@ (Do not change this line.)


AREA UserModules (ROM, REL)

;-----------------------------------------------------------------------------
;  FUNCTION NAME: _TimerRTC_ISR
;
;  DESCRIPTION: Unless modified, this implements only a null handler stub.
;
;-----------------------------------------------------------------------------
;

_TimerRTC_ISR:

   ;@PSoC_UserCode_BODY@ (Do not change this line.)
    ;---------------------------------------------------
    ; Insert your custom code below this banner
    ;---------------------------------------------------

	;***************************************************************************
	; PSoC100
	;
	; time_slot.c
	; TimerRTCINT.asm
	;***************************************************************************
	; COMENTARIOS:
	;***************************************************************************
	;
	;  DESCRICAO:
	;		Rotina da iterrupcao para do modulo Timer8:
	;       TimerRTC.
	;
	;***************************************************************************
	;
	; Salva registros A e X
	push X
	push A
	; RTOS_Temp --> X+0
	; int	RTOS_Temp
	PUSH  X
	MOV   X,SP
	; RTOS_Temp =  slice_counter++
	MOV   A,[_slice_counter+1]
	MOV   [X+1],A
	MOV   A,[_slice_counter]
	MOV   [x],A
	ADD   [_slice_counter+1],1
	ADC   [_slice_counter],0
	; time_slot_counter |= ((RTOS_Temp ^ slice_counter) + 1)
	MOV   A,[X+1]
	XOR   A,[_slice_counter+1]
	MOV   [X+1],A
	MOV   A,[X]
	XOR   A,[_slice_counter]
	MOV   [X],A
	ADD   [X+1],1
	ADC   [X],0
	MOV   A,[X+1]
	OR    [_time_slot_counter+1],A
	MOV   A,[X]
	OR    [_time_slot_counter],A
	POP   X
	; Restaura A e X
	pop  A
	pop  X

    ;---------------------------------------------------
    ; Insert your custom code above this banner
    ;---------------------------------------------------
   ;@PSoC_UserCode_END@ (Do not change this line.)

   reti


; end of file TimerRTCINT.asm
