#include <m8c.h>        // part specific constants and macros
#include "PSoCAPI.h"    // PSoC API definitions for all User Modules
//***************************************************************************
// Definio das constantes
//***************************************************************************
#define   bit0            0b00000001
#define   bit1            0b00000010
#define   bit2            0b00000100
#define   bit3            0b00001000
#define   bit4            0b00010000
#define   bit5            0b00100000
#define   bit6            0b01000000
#define   bit7            0b10000000

#define   true   255
#define   false   0

// **************************************************************************************************

// Liga/desliga LED de teste
#define ACONTR      gflag |= bit0   
#define DCONTR      gflag &= ~bit0
#define ADCONTR      gflag ^= bit0
#define IFCONTR     (gflag & bit0)


// Liga/desliga LED de teste
#define LEDTON      PRT0DR |=  bit2   
#define LEDTOFF      PRT0DR &= ~bit2
#define LEDTONOFF   PRT0DR ^=  bit2
#define IFLED        (PRT0DR & bit2)

#define  RS_1      PRT0DR |=  bit7
#define  RS_0      PRT0DR &= ~bit7
#define  RESET_1   PRT0DR |=  bit6
#define  RESET_0   PRT0DR &= ~bit6
#define  CS_1      PRT0DR |=  bit5
#define  CS_0      PRT0DR &= ~bit5
#define  SCLK_1      PRT0DR |=  bit4
#define  SCLK_0      PRT0DR &= ~bit4
#define  SDATA_1   PRT0DR |=  bit3
#define  SDATA_0   PRT0DR &= ~bit3




#define  t_mas    (PRT1DR & bit0)
#define  t_mns    (PRT1DR & bit1)

// LCDs


//16Bit Color -> RRRRRGGGGGBBBBB
#define Lila 0b1111100000011111
#define Blau 0b0000000000011111
#define Weiss 0xFFFF
#define Schwarz 0x00
#define Rot 0b1111100000000000
#define Gruen 0b0000011111100000
#define Cyan 0b0000011111111111
#define Gold 0b1111111111100000
#define Grau 0b1111111111110110
#define Hgelb 0b1111011110101000
#define Dgelb 0b1111011111010000


//####################################################################
// Wir AREF = Ub genommen bitte Messen und Hier bei AREF eintragen.
// Interne AREF =2,56V -> siehe datenblatt!
//####################################################################

#define Aref 2.56
#define N = Aref / 1024

#define hwstack 128
#define swstack 128
#define framesize 128


void S65_cls(double Bcol);
void S65_init(void);
void S65_line(unsigned char Lx1, unsigned char Ly1, unsigned char Lx2, unsigned char Ly2, double Color);
void S65_pset(unsigned char Lx, unsigned char Ly, double Color);
void spi(unsigned int dat);
void LCDVLine(unsigned char xs, unsigned char ys, unsigned char length, double color);
void LCDHLine(unsigned char xs, unsigned char ys, unsigned char length, double color);
void LCDString (unsigned char xc, unsigned char yc, unsigned char Size, long StrNo, double color);
void Character (unsigned char Size, unsigned char xc, unsigned char yc, unsigned char _char, double color);


#define _5x7Font        0
#define _8x10Font       1



#define CHAR_H 14
#define CHAR_W 8
#define TEXT_COL 16
#define TEXT_ROW 12


//#BYTE    SSPCON1  =     0xFC6
//#bit     SSPEN    =     SSPCON1.5
// Tamanho do Display
// ------------------

#define LANDSCAPE   1
//#define PORTRAIT   1

#ifdef LANDSCAPE
   #define X 176
   #define Y 132
   #define LARGURA_LCD      176
   #define ALTURA_LCD      132
   #define DISP_W 132
   #define DISP_H 176
   #else
   #ifdef PORTRAIT
      #define X 132
      #define Y 176
      #define LARGURA_LCD      132
      #define ALTURA_LCD      176
      #define DISP_W 132
      #define DISP_H 176
   #endif
#endif

#define   INICIO_CURVA   12
#define   FINAL_CURVA      LARGURA_LCD - 55
#define TAM_MAX_PLOT   FINAL_CURVA - INICIO_CURVA 
#define LINHA_BASE_ECG   ALTURA_LCD/2

#define RESOLUTION 12                    // ADC resolution
#define SCALE_BG  (( 1 << RESOLUTION)/20) // BarGraph scale factor

