;***************************************************************************
; PSoC100
;
; delay.asm
;
; Firmware do teclado para PSoC100.00
; Copyright (c) 2003 CmosDrake.
; Todos Direitos Reservados.
;
; CORRECOES:
;
; Verso	Data		Por				Modificaes
;
; 01.00 23/03/2003  Luiz Mattos  	- Verso original
;
;***************************************************************************
; COMENTARIOS:
;***************************************************************************

export  delay_us
export _delay_us
export  delay_ms
export _delay_ms
export  delay_us4
export _delay_us4

include "m8c.inc"

area    text(ROM,REL)

;***************************************************************************
; delay_us
;
; Descrio  : Delay us em 24Mhz ==> cycle (periodo) = 41,6666.. ns
;              A = 0x00 ==> 256 us
; Argumentos : t = tempo de atraso em us
; Retorno    : no
;
;***************************************************************************

delay_us:							; Delay Total = 19+(A*25) cycles
_delay_us:							; 11 cycles para call
	dec  A							; 4 cycles
	nop								; 4 cycles
	nop								; 4 cycles
	nop								; 4 cycles
	nop								; 4 cycles
	jnz  delay_us					; 5 cycles para jump, 4 sem jump
	ret								; 8 cycles
	
    
;***************************************************************************
; delay_ms
;
; Descrio  : Delay ms em 24Mhz
;			   A = 0x00 ==> 256 ms
; Argumentos : t = tempo de atraso em ms
; Retorno    : no
;
;***************************************************************************

delay_ms:							; Delay Total = 19+(A*25) cycles
_delay_ms:							; 11 cycles para call
	dec  A							; 4 cycles
	push A							; 4 cycles
	mov  A,249						; 4 cycles
	call delay_us					; Delay 250us
	mov  A,249						; 4 cycles
	call delay_us					; Delay 250us
	mov  A,249						; 4 cycles
	call delay_us					; Delay 250us
	mov  A,249						; 4 cycles
	call delay_us					; Delay 250us
	pop  A							; 5 cycles
	jnz  delay_ms					; 5 cycles para jump, 4 sem jump
	ret								; 8 cycles


;***************************************************************************
; delay_us/4
;
; Descrio  : Delay us em 24Mhz ==> cycle (periodo) = 41,6666.. ns
;              A = 0x00 ==> 256 us
; Argumentos : t = tempo de atraso em us
; Retorno    : no
;
;***************************************************************************

delay_us4:							; Delay Total = 19+(9) cycles
_delay_us4:							; 11 cycles para call
	dec  A							; 4 cycles
	jnz  delay_us					; 5 cycles para jump, 4 sem jump
	ret								; 8 cycles