//********************************************************
// Project:     LCDColor
// Title:      main.c
// Description:   Siemens 176x132 Color LCD Test Code
// Version:      V1.0
// Compiler:    
//********************************************************
#define VERSION 1
#define ISSUE 1

// Include Standard files
#include "define.h"
#include "delay.h"
#include "time_slot.h"
#include "spi.h"                    // 9-bit SPI routines using standard I/O pins
#include  "PWM8_1.h"

// Globals
signed char CursorX;                       // Pixel cursor for drawing characters
signed char CursorY;

char contraste=50;                       
unsigned char gflag=0;
unsigned char oldt_mas=0;

BYTE bgPos;                          // BarGraph position
int  iResult;                            // ADC result variable

unsigned short backcolor=0xFFFF;    // color of background
unsigned short textcolor=0x0000;


void main()
{
    int i;

    M8C_EnableGInt;                      // Enable Global interrupts

    
   PRT1DR=0;

   TimerRTC_WritePeriod(0x07);
   TimerRTC_WriteCompareValue(0x00);

   TimerRTC_EnableInt();           
   TimerRTC_Start(); 
   M8C_EnableGInt;

    UART_1_Start(UART_PARITY_NONE);      // Enable UART
    UART_1_CPutString("Carlos Magno"); // Example string
    UART_1_PutCRLF();
     
    PGA_1_SetGain(PGA_1_G1_00);
   PGA_1_Start(PGA_1_MEDPOWER);         // Turn on PGA power
    ADCINC12_1_Start(ADCINC12_1_HIGHPOWER); // Turn on ADC power
    ADCINC12_1_GetSamples(0);            // Sample forever



    /* set period to eight clocks */ 
    PWM8_1_WritePeriod(100); 
    PWM8_1_WritePulseWidth(contraste);  
    /* ensure interrupt is disabled */  
    PWM8_1_DisableInt();  
    /* start the PWM8! */  
    PWM8_1_Start();  

    test();



   while (1)
   {
      

      if (t_mas)
      {
         if(oldt_mas!=t_mas)ADCONTR;
         if (IFCONTR)
         {
            delay_ms(100); 
            contraste++; 
            if(contraste>100){contraste=100;};
            PWM8_1_WritePulseWidth(contraste);
            
         }
         else 
         {
            delay_ms(100);
            contraste--; 
            if(contraste==255) contraste=0;
            PWM8_1_WritePulseWidth(contraste);
            
         }
         oldt_mas=t_mas;
      }
      
   
      if (ADCINC12_1_fIsDataAvailable() != 0) // If ADC sample is ready...
      {
         iResult = ADCINC12_1_iGetData() + 2048; // Get result, convert to unsigned and clear flag
         ADCINC12_1_ClearFlag();
         
         //UART_1_PutSHexInt(iResult);    // Print result to UART
          UART_1_SendData((iResult>>8) & 0xff);
          UART_1_SendData(iResult & 0xff);
          //UART_1_SendData(',')  

         //UART_1_PutCRLF();              // Tack on a CR and LF
      
         bgPos =  128 - (BYTE)(iResult/32 & 0x7F);
      }
      

   }
}


void test()
{
   unsigned char  T, Xy, Timeb;

   S65_init();
   
   S65_cls(Schwarz);

   S65_line(40, 40, 60, 60, Hgelb);

   S65_line(40, 40, 60, 80, Cyan);
   S65_line(40, 40, 80, 60, Rot);

//######################################
//'       Kreuz zeichen - Sinal de Cruz
//######################################
   for(Xy=30;Xy<=50;Xy++){
    S65_pset(Xy, 40, Hgelb);
    S65_pset(40, Xy, Hgelb);
   
   }
   
   for(Xy=20;Xy<=100;Xy++)
      S65_pset(Xy, 30, Cyan);


//'#####################################
//'  Titelscreen - Tela inicial
//'#####################################
   S65_cls(Schwarz);
   //timebase fr DIV/T 1..6
   Timeb = 1;
   
   LCDString(10,10,_5x7Font,0,Weiss);
   
   LCDVLine(X/2,0,Y,Lila);                      // Top horizontal
   
   //S65_line(20 , 20 , 80 , 170 , Cyan)
   S65_line(20, 20, 120, 20, Cyan);
   for(Xy=20;Xy<=175;Xy++)
      S65_pset(20, Xy, Cyan);

   LEDTON;
}

